#include <time.h>
#include "rsync.h"

// gotten from io.c
#define SELECT_TIMEOUT 60

void initGlobals() {
	/*
		 added these vars myself for qsync functionality
	 */

	extern int eventPipe[2];

	/*
		 collected this with
		 grep -v ^static ../../misc/rsyncGlobalsList | grep = | cut -d ' ' -f 1-2 > setGlobals.c
	*/

	extern int csum_length;
	extern int remote_protocol;
		
	extern struct exclude_list_struct exclude_list;
	extern struct exclude_list_struct local_exclude_list;
	extern struct exclude_list_struct server_exclude_list;
	
	extern char *exclude_path_prefix;
	extern int select_timeout;
	extern int batch_fd;
	extern int batch_gen_fd;
	extern int kludge_around_eof;
	extern int msg_fd_in;
	extern int msg_fd_out;
	extern int log_got_error;
	extern time_t starttime;
	extern int make_backups;
	extern int whole_file;
	extern int archive_mode;
	extern int keep_dirlinks;
	extern int copy_links;
	extern int preserve_links;
	extern int preserve_hard_links;
	extern int preserve_perms;
	extern int preserve_devices;
	extern int preserve_uid;
	extern int preserve_gid;
	extern int preserve_times;
	extern int update_only;
	extern int cvs_exclude;
	extern int dry_run;
	extern int local_server;
	extern int ignore_times;
	extern int delete_mode;
	extern int delete_excluded;
	extern int one_file_system;
	extern int protocol_version;
	extern int sparse_files;
	extern int do_compression;
	extern int am_root;
	extern int orig_umask;
	extern int relative_paths;
	extern int implied_dirs;
	extern int numeric_ids;
	extern int force_delete;
	extern int io_timeout;
	extern int read_only;
	extern int module_id;
	extern int am_server;
	extern int am_sender;
	extern int am_generator;
	extern char *files_from;
	extern int filesfrom_fd;
	extern char *remote_filesfrom_file;
	extern int eol_nulls;
	extern int recurse;
	extern int am_daemon;
	extern int daemon_over_rsh;
	extern int do_stats;
	extern int do_progress;
	extern int keep_partial;
	extern int safe_symlinks;
	extern int copy_unsafe_links;
	extern int size_only;
	extern int bwlimit;
	extern size_t bwlimit_writemax;
	extern int delete_after;
	extern int only_existing;
	extern int opt_ignore_existing;
	extern int max_delete;
	extern int ignore_errors;
	extern int modify_window;
	extern int blocking_io;
	extern int checksum_seed;
	extern int inplace;
	extern unsigned int block_size;
	extern int default_af_hint;
	extern int no_detach;
	extern int write_batch;
	extern int read_batch;
	extern int backup_dir_len;
	extern char *backup_suffix;
	extern char *tmpdir;
	extern char *partial_dir;
	extern char *compare_dest;
	extern char *config_file;
	extern char *shell_cmd;
	extern char *log_format;
	extern char *password_file;
	extern char *rsync_path;
	extern char *backup_dir;
	extern int rsync_port;
	extern int link_dest;
	extern int verbose;
	extern int quiet;
	extern int always_checksum;
	extern int list_only;
	extern char *batch_name;
	extern int sanitize_paths;
	/*extern int fnmatch_errors;
	extern int wildmatch_errors;
	extern int output_iterations; */

	/*
		 added these vars myself for qsync functionality
	 */

	/* make sure these aren't stale - they're re-opened before the fork */
	if (eventPipe[0])
		close(eventPipe[0]);
	if (eventPipe[1])
		close(eventPipe[1]);

	/*
		 fetched this stuff with
		 grep -v ^static ../../misc/rsyncGlobalsList | grep = | cut -d ' ' -f 2- >> setGlobals.c
	*/

	csum_length=2; /* initial value */
	remote_protocol = 0;
	
	/* FIXME: why is { brace, notation, failing}?  this would be cleaner... */
	exclude_list.head = 0;
	exclude_list.tail = 0;
	exclude_list.debug_type = "";
	local_exclude_list.head = 0;
	local_exclude_list.tail = 0;
	local_exclude_list.debug_type = "per-dir .cvsignore ";
	server_exclude_list.head = 0;
	server_exclude_list.tail = 0;
	server_exclude_list.debug_type = "server ";
	
	exclude_path_prefix = NULL;
	select_timeout = SELECT_TIMEOUT;
	batch_fd = -1;
	batch_gen_fd = -1;
	kludge_around_eof = False;
	msg_fd_in = -1;
	msg_fd_out = -1;
	log_got_error = 0;
	starttime = 0;
	make_backups = 0;
	whole_file = -1;
	archive_mode = 0;
	keep_dirlinks = 0;
	copy_links = 0;
	preserve_links = 0;
	preserve_hard_links = 0;
	preserve_perms = 0;
	preserve_devices = 0;
	preserve_uid = 0;
	preserve_gid = 0;
	preserve_times = 0;
	update_only = 0;
	cvs_exclude = 0;
	dry_run = 0;
	local_server = 0;
	ignore_times = 0;
	delete_mode = 0;
	delete_excluded = 0;
	one_file_system = 0;
	protocol_version = PROTOCOL_VERSION;
	sparse_files = 0;
	do_compression = 0;
	am_root = 0;
	orig_umask = 0;
	relative_paths = -1;
	implied_dirs = 1;
	numeric_ids = 0;
	force_delete = 0;
	io_timeout = 0;
	read_only = 0;
	module_id = -1;
	am_server = 0;
	am_sender = 0;
	am_generator = 0;
	files_from = NULL;
	filesfrom_fd = -1;
	remote_filesfrom_file = NULL;
	eol_nulls = 0;
	recurse = 0;
	am_daemon = 0;
	daemon_over_rsh = 0;
	do_stats = 0;
	do_progress = 0;
	keep_partial = 0;
	safe_symlinks = 0;
	copy_unsafe_links = 0;
	size_only = 0;
	bwlimit = 0;
	bwlimit_writemax = 0;
	delete_after = 0;
	only_existing = 0;
	opt_ignore_existing = 0;
	max_delete = 0;
	ignore_errors = 0;
	modify_window = 0;
	blocking_io = -1;
	checksum_seed = 0;
	inplace = 0;
	block_size = 0;

	/* from options.c */
	#ifdef INET6
		default_af_hint = 0;	/* Any protocol */
	#else
		default_af_hint = AF_INET;	/* Must use IPv4 */
	#endif

	no_detach = 0;
	write_batch = 0;
	read_batch = 0;
	backup_dir_len = 0;
	backup_suffix = NULL;
	tmpdir = NULL;
	partial_dir = NULL;
	compare_dest = NULL;
	config_file = NULL;
	shell_cmd = NULL;
	log_format = NULL;
	password_file = NULL;
	rsync_path = RSYNC_PATH;
	backup_dir = NULL;
	rsync_port = RSYNC_PORT;
	link_dest = 0;
	verbose = 0;
	quiet = 0;
	always_checksum = 0;
	list_only = 0;
	batch_name = NULL;
	sanitize_paths = 0;
	/*fnmatch_errors = 0;
	wildmatch_errors = 0;
	output_iterations = 0;*/

}
