#include <iostream>
#include <qapplication.h>
#include <qevent.h>
#include "customevents.h"
#include "syncprocess.h"
#include "syncthread.h"
#include "dlgstatus.h"

using namespace std;

extern "C" int rsync_main(int argc,char *argv[]);

/* the function pointers blow are wrappers for some C++ functions, so
	 rsync's C code can call the functions to update the gui with any
	 transfer/listing/etc info.  the dialog instance pointers are set
	 in the DlgMain constructor below.
 */

extern DlgStatus *statusDlgPtr;
extern SyncProcess *SyncProcessPtr;
extern SiteInfo *siteInfoPtr;
extern SyncThread *syncThreadPtr;

// adds remote files listed by the rsync server
void qsAddListItem2(char *perms, char *size, char *modtime, char *name) {
	QStringList *args = new QStringList();
	QCustomEvent *ce = new QCustomEvent(EVENT_ADD_REMOTE);
	args->append(perms);
	args->append(size);
	args->append(modtime);
	args->append(name);
	ce->setData(args);
	QApplication::postEvent(statusDlgPtr, ce);
}
void (*qsAddListItem)(char *, char *, char *, char *) = &qsAddListItem2;

// gathers rsync motd and/or module listing
void qsAddRsyncSpew2(char *s) { SyncProcessPtr->addRsyncSpew(s); }
void (*qsAddRsyncSpew)(char *) = &qsAddRsyncSpew2;

// hands rsync the password when it wants it
char *qsGetSitePass2() {
	cout << "GETTING PASSWORD" << endl;
	return (char *)siteInfoPtr->getPass().c_str();
}
char *(*qsGetSitePass)() = &qsGetSitePass2;

void SyncThread::cleanExit(int eventNum) {
	cout << "  HANDLE of thread in cleanExit(): " << QThread::currentThread() << endl;
	cout << "  HANDLE of thread in cleanExit(): " << QThread::currentThread() << endl;
	QCustomEvent *ce = new QCustomEvent(eventNum);
	QApplication::postEvent(syncProcess, ce);
	//if (EVENT_RSYNC_DONE == eventNum)
		this->exit();
	//else cout << "NOT EXITING" << endl;
}

void SyncThread::run() {
	cout << "HANDLE of thread in RUN(): " << QThread::currentThread() << endl;
	cout << "HANDLE of thread in RUN(): " << QThread::currentThread() << endl;
	cout << "HANDLE of thread in RUN(): " << QThread::currentThread() << endl;
	rsync_main(rsyncArgCount, rsyncArgs);
}

void SyncThread::setArgs(int argCount, char *args[]) {
	rsyncArgCount = argCount;
	// TODO: is this following line even right? doublecheck this sometime...
	rsyncArgs = (char **)malloc(argCount * sizeof(char *));
	for (int i = 0; i < argCount; i++)
		rsyncArgs[i] = args[i];
}

void SyncThread::setSyncProcess(SyncProcess *sp) {
	syncProcess = sp;
}
